package com.engine.organization.service;

import com.api.browser.bean.SearchConditionGroup;
import com.engine.organization.entity.fieldset.vo.TypeTreeVO;
import com.engine.organization.entity.hrmresource.po.ResourceItemClassPO;
import com.engine.organization.entity.hrmresource.po.ResourceItemPO;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author weaver_cl
 * @Description:
 * @Date 2022/8/23
 * @Version V1.0
 **/
public interface ResourceBasicInfoService {

    /**
     * 列表
     *
     * @param params
     * @return
     */
    Map<String, Object> listPage(Map<String, Object> params);

    /**
     * 获取左侧树
     *
     * @return
     */
    List<TypeTreeVO> getTreeData();

    /**
     * 新增编辑表单
     *
     * @param params
     * @return
     */
    List<SearchConditionGroup> getForm(Map<String, Object> params);

    /**
     * 删除/批量删除人员信息资料
     *
     * @param ids
     * @return
     */
    int deletByIds(Collection<Long> ids);

    /**
     * 恢复人员信息资料
     *
     * @param ids
     * @return
     */
    int recoverByIds(Collection<Long> ids);

    /**
     * 保存人员信息资料
     *
     * @param resourceItemPO
     * @return
     */
    int save(ResourceItemPO resourceItemPO);

    /**
     * 根据id获取人员信息资料
     *
     * @param fid
     * @return
     */
    ResourceItemPO selectById(Integer fid);

    /**
     * 更新人员信息资料
     *
     * @param resourceItemPO
     * @return
     */
    int update(ResourceItemPO resourceItemPO);


    /**
     * 分类，新增编辑表单
     *
     * @param params
     * @return
     */
    List<SearchConditionGroup> getItemClassForm(Map<String, Object> params);

    /**
     * 新增分类
     *
     * @param itemClassPO
     * @return
     */
    int saveResourceItemClass(ResourceItemClassPO itemClassPO);

    /**
     * 更新分类
     *
     * @param itemClassPO
     * @return
     */
    int updateResourceItemClass(ResourceItemClassPO itemClassPO);

    /**
     * 删除分类
     *
     * @param fid
     * @return
     */
    int deleteResourceItemClass(Integer fid);

    /**
     * 搜索条件
     *
     * @return
     */
    List<SearchConditionGroup> getSearchCondition();

}
